#ifndef BALL_H_
#define BALL_H_

#include "vec.h"

class Ball {
public :
	Vec _pos; // position du centre
	double _rad; // rayon
	Vec _vel; // velocit
	double _mass; // masse
	double _invMass; // inverse de la masse

public :
	Ball(){
		_pos = Vec();
		_rad = 1.0;
		_vel = Vec();
		_mass = 0.0; // objet cr statique
		_invMass = 0.0;
	};

	Ball(Vec pos, double rad, Vec vel, double mass) {
		_pos = pos;
		_rad = rad;
		_vel = vel;
		_mass = mass;
		if (_mass>0) {
			_invMass = 1.0/mass;
		} else {
			_invMass = 0.0;
		}
	}

	~Ball(){};
};

#endif