#include "matrix.h"

// m = [m[0] m[2]
//      m[1] m[3]]
int Matrix::inverseMatrix(double* invM) {
	double det = _m[0]*_m[3]-_m[1]*_m[2];

	if (det==0) {
		printf("Matrice singulire\n");
		return 0;
	}

	invM[0] = _m[3]/det;
	invM[1] = -_m[1]/det;
	invM[2] = -_m[2]/det;
	invM[3] = _m[0]/det;

	return 1;
}

int Matrix::inverseMatrix() {
	double det = _m[0]*_m[3]-_m[1]*_m[2];

	if (det==0) {
		printf("Matrice singuliere\n");
		return 0;
	}

	double auxM[4];
	auxM[0] = _m[0];
	auxM[1] = _m[1];
	auxM[2] = _m[2];
	auxM[3] = _m[3];

	_m[0] = auxM[3]/det;
	_m[1] = -auxM[1]/det;
	_m[2] = -auxM[2]/det;
	_m[3] = auxM[0]/det;

	/*double test = _m[0]*auxM[0] + _m[2]*auxM[1];
	printf("TEST=\n%f ", test);
	test = _m[0]*auxM[2] + _m[2]*auxM[3];
	printf("%f\n", test);
	test = _m[1]*auxM[0] + _m[3]*auxM[1];
	printf("%f ", test);
	test = _m[1]*auxM[2] + _m[3]*auxM[3];
	printf("%f\n", test);
	printf("\n");*/

	return 1;
}

void Matrix::multMatVec(Vec vec, Vec* res) {
	res->x = vec.x*_m[0] + vec.y*_m[2];
	res->y = vec.x*_m[1] + vec.y*_m[3];
}

void Matrix::multMatSca(double k) {
	_m[0] *= k;
	_m[1] *= k;
	_m[2] *= k;
	_m[3] *= k;
}