#ifndef SPRING_H_
#define SPRING_H_

#include <vector>
using namespace std;

#include "vec.h"

class Spring {
public :
	double _stiffness; // elasticit
	double _length; // longueur au repos
	double _damp; // facteur d'amortissement

	int _m1; // indice de la premire massse
	int _m2; // indice de la deuxime masse

public :
	Spring(){};

	Spring(int m1, int m2, double stiffness, double length, double damp) {
		_m1 = m1;
		_m2 = m2;
		_stiffness = stiffness;
		_length = length;
		_damp = damp;
	}

	~Spring(){};

	// Ajoute la force exerce par ce ressort au systme dynamique :
	void addForce(vector<Vec>& forces, vector<Vec> positions, vector<Vec> velocities );	
};

#endif